#include "COM.h"

int COM::AbrirCOM(char* COM_PORT)
{
    idComDev = CreateFile(COM_PORT, GENERIC_READ | GENERIC_WRITE,
                        0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
                        
    if(idComDev ==INVALID_HANDLE_VALUE)
    {
        printf("Error 1, puerto serie: %d\n", GetLastError()); 
        return false;
    }
    
    dcb.DCBlength=sizeof(dcb);
    
    if(!GetCommState(idComDev, &dcb))
    { 
        printf("Error 2, puerto serie\n"); 
        return false; 
    }
    
    dcb.BaudRate = (DWORD) CBR_115200;
    dcb.ByteSize = (BYTE) 8;
    dcb.Parity   = (BYTE) NOPARITY;
    dcb.StopBits = (BYTE) ONESTOPBIT;
    
    if(!SetCommState(idComDev, &dcb))
    { 
        printf("Error 3, SetCommStatus\n"); 
        return false;
    }
    
    COMMTIMEOUTS timeouts={0};
    timeouts.ReadIntervalTimeout = 50;
    timeouts.ReadTotalTimeoutConstant = 50;
    timeouts.ReadTotalTimeoutMultiplier = 10;
    timeouts.WriteTotalTimeoutConstant = 50;
    timeouts.WriteTotalTimeoutMultiplier = 10;
    
    if(!SetCommTimeouts(idComDev,&timeouts))
    { 
        printf("Error 4, timeouts\n"); 
        return false; 
    }  
    return true;
}

void COM::CerrarCOM()
{
    CloseHandle(idComDev);
}

void COM::EscribirCOM(char* buffer)  //buffer donde se encuentran los caracteres a escribir
{
    DWORD numbytes = 0;
    if(WriteFile(idComDev, buffer, PCFRAME, &numbytes, NULL))
        printf("Escritura con exito\n");
    else
        printf("Error en la escritura\n"); 
}

void COM::LeerCOM(char* buffer, int size)    //buffer donde se almacenarn los caracteres y el tamao de la lectura
{
    DWORD numbytes = 0;
    if(ReadFile(idComDev, buffer, size, &numbytes, NULL))
        printf("Lectura con exito\n");
    else
        printf("Error en la lectura\n");
}

////////////////////IMPORTANTE///////////////////////////

//printf deja de mostrar datos en la consola en el momento en que detecta un ASCII 0 (0x00)

////////////////////////////////////////////////////////

void COM::IniciarCOM(char* path)     //path = variable donde se almacenar el path del COM
{
    int i;
    for (i=20;i>1;i--) 
    {
        sprintf(path,"\\\\.\\COM%d",i);    
        if(AbrirCOM(path))
            goto L1;
        CerrarCOM();
    }
    printf("*** Puerto serie no encontrado\n");
    while(1);
L1:  
    CerrarCOM();    
    printf("Puerto serie: %d\nVelocidad: 115200 baudios\n",i);
}

void COM::makeframe(char *buff, char *command, char len)
{
	while(len--)
		*buff++ = *command++;
}

void COM::initialize_vector(char *buff, int length)
{
	while(length--)
		*buff++ = 0;	
}

void COM::envia_trama(char *address_slave, char *command, char *data)
{
    int i;
    
    initialize_vector(pc_frame,PCFRAME);
    makeframe(pc_frame,address_slave,ADDRESS_LENGTH);
    makeframe(&pc_frame[4],command,1);
    makeframe(&pc_frame[5],data,6);
    makeframe(&pc_frame[11],&EOFr,1);
    
    for(i=0;i<12;i++)
       printf("Caracter %c\n",pc_frame[i]);
    
    EscribirCOM(pc_frame);
}












