///-----------------------------------------------------------------
///
/// @file      RadioTransceiverDlg.cpp
/// @author    user
/// Created:   08/02/2015 20:13:45
/// @section   DESCRIPTION
///            RadioTransceiverDlg class implementation
///
///------------------------------------------------------------------

#include "RadioTransceiverDlg.h"

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// RadioTransceiverDlg
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(RadioTransceiverDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(RadioTransceiverDlg::OnClose)
	EVT_BUTTON(ID_BTN_DELETE_SLAVE,RadioTransceiverDlg::btn_delete_slaveClick)
	EVT_BUTTON(ID_BTN_TEMPERATURE,RadioTransceiverDlg::btn_temperatureClick)
	EVT_BUTTON(ID_BTN_SAVE_BBDD,RadioTransceiverDlg::btn_save_bbddClick)
	EVT_BUTTON(ID_BTN_CLOSE_COM,RadioTransceiverDlg::btn_close_comClick)
	EVT_COMBOBOX(ID_CMB_SLAVE_VIEW,RadioTransceiverDlg::cmb_slave_viewSelected)
	EVT_BUTTON(ID_BTN_RECOVER_CONFIG,RadioTransceiverDlg::btn_recover_configClick)
	EVT_BUTTON(ID_BTN_SEARCH_SLAVE,RadioTransceiverDlg::btn_search_slaveClick)
	EVT_BUTTON(ID_BTN_SEND_FRAME,RadioTransceiverDlg::btn_send_frameClick)
	EVT_BUTTON(ID_BTN_LOAD_BBDD,RadioTransceiverDlg::btn_load_bbddClick)
	EVT_BUTTON(ID_BTN_CONNECT_COM,RadioTransceiverDlg::btn_connect_comClick)
	EVT_COMBOBOX(ID_CMB_DATA,RadioTransceiverDlg::cmb_dataSelected)
	EVT_COMBOBOX(ID_CMB_COMMAND,RadioTransceiverDlg::cmb_commandSelected)
	EVT_COMBOBOX(ID_CMB_SLAVE_ADDRESS,RadioTransceiverDlg::cmb_slave_addressSelected)
END_EVENT_TABLE()
////Event Table End

RadioTransceiverDlg::RadioTransceiverDlg(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
    button_bbdd = 0;
    ////////////////////COM inicializacion///////////////////////////
    
    dcb = {0};
    pc_frame[PCFRAME]={0};      //Vector que almacenar el emnsaje a enviar
    EOFr = 'L';                 //Caracter ASCII L (End Of Frame) 
    buf_RX[SIZE_BUFF]={0};      //Buffer de recepcin
    
    ////////////////////COM inicializacion///////////////////////////
    
    ////////////////////SLAVE inicializacion///////////////////////////
    
    strcpy(&pin_name[0][0],"ORANGE");           //PIO1_14
    strcpy(&pin_name[1][0],"PIO1_22");
    strcpy(&pin_name[2][0],"PIO0_15");
    strcpy(&pin_name[3][0],"PIO0_16");
    strcpy(&pin_name[4][0],"PIO0_17");
    strcpy(&pin_name[5][0],"PIO0_18");
    strcpy(&pin_name[6][0],"PIO0_19");
    strcpy(&pin_name[7][0],"PIO1_16");
    
    strcpy(&pin_number[0][0],"000003");
    strcpy(&pin_number[1][0],"000046");         //22 + 24(PORT0)
    strcpy(&pin_number[2][0],"000015");
    strcpy(&pin_number[3][0],"000016");
    strcpy(&pin_number[4][0],"000017");
    strcpy(&pin_number[5][0],"000018");
    strcpy(&pin_number[6][0],"000019");
    strcpy(&pin_number[7][0],"000040");         //16 + 24(PORT0)
    
    strcpy(&command_name[0][0],"READ PINS");    //Commandos
    strcpy(&command_name[1][0],"BROADCAST");
    strcpy(&command_name[2][0],"SET PIN");
    strcpy(&command_name[3][0],"RESET PIN");   
    
    strcpy(&command_number[0][0],"1");
    strcpy(&command_number[1][0],"2");
    strcpy(&command_number[2][0],"3");
    strcpy(&command_number[3][0],"4"); 
    strcpy(&command_number[4][0],"5");
    strcpy(&command_number[5][0],"6");          
                               
    ////////////////////SLAVE inicializacion///////////////////////////
    
    ////////////////////SLAVE LIST inicializacion///////////////////////////
    
    list_slave = {0};
    
    ////////////////////SLAVE LIST inicializacion///////////////////////////
    
	CreateGUIControls();
	
	Inicialization();
}

RadioTransceiverDlg::~RadioTransceiverDlg()
{
} 

void RadioTransceiverDlg::Inicialization()
{
    cmb_slave_address->Disable();   //Desactivamos todos los botones
    cmb_command->Disable();
    cmb_data->Disable();
    cmb_slave_view->Disable();
    cmb_recover_config->Disable();
    
    btn_close_com->Disable();
    btn_recover_config->Disable();
    btn_search_slave->Disable();
    btn_delete_slave->Disable();
    btn_load_bbdd->Disable();   
    btn_send_frame->Disable();
    btn_save_bbdd->Disable();
    btn_temperature->Disable();
}

void RadioTransceiverDlg::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End.
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	btn_delete_slave = new wxButton(this, ID_BTN_DELETE_SLAVE, _("Delete Slave"), wxPoint(328, 335), wxSize(75, 25), 0, wxDefaultValidator, _("btn_delete_slave"));

	txt_temperature = new wxTextCtrl(this, ID_TXT_TEMPERATURE, _(""), wxPoint(153, 377), wxSize(60, 19), wxTE_READONLY, wxDefaultValidator, _("txt_temperature"));

	WxStaticText16 = new wxStaticText(this, ID_WXSTATICTEXT16, _("C"), wxPoint(216, 377), wxDefaultSize, 0, _("WxStaticText16"));

	btn_temperature = new wxButton(this, ID_BTN_TEMPERATURE, _("Temperature"), wxPoint(30, 375), wxSize(75, 25), 0, wxDefaultValidator, _("btn_temperature"));

	btn_save_bbdd = new wxButton(this, ID_BTN_SAVE_BBDD, _("Save BBDD"), wxPoint(490, 70), wxSize(75, 25), 0, wxDefaultValidator, _("btn_save_bbdd"));

	btn_close_com = new wxButton(this, ID_BTN_CLOSE_COM, _("Close COM"), wxPoint(490, 31), wxSize(75, 25), 0, wxDefaultValidator, _("btn_close_com"));

	WxStaticText15 = new wxStaticText(this, ID_WXSTATICTEXT15, _("Slave Pins View"), wxPoint(559, 100), wxDefaultSize, 0, _("WxStaticText15"));

	wxArrayString arrayStringFor_cmb_slave_view;
	cmb_slave_view = new wxComboBox(this, ID_CMB_SLAVE_VIEW, _(""), wxPoint(530, 122), wxSize(145, 23), arrayStringFor_cmb_slave_view, wxCB_DROPDOWN | wxCB_READONLY | wxCB_SORT, wxDefaultValidator, _("cmb_slave_view"));

	txt_pin_8 = new wxTextCtrl(this, ID_TXT_PIN_8, _(""), wxPoint(600, 370), wxSize(45, 19), wxTE_READONLY, wxDefaultValidator, _("txt_pin_8"));

	txt_pin_7 = new wxTextCtrl(this, ID_TXT_PIN_7, _(""), wxPoint(600, 340), wxSize(45, 19), wxTE_READONLY, wxDefaultValidator, _("txt_pin_7"));

	txt_pin_6 = new wxTextCtrl(this, ID_TXT_PIN_6, _(""), wxPoint(600, 310), wxSize(45, 19), wxTE_READONLY, wxDefaultValidator, _("txt_pin_6"));

	txt_pin_5 = new wxTextCtrl(this, ID_TXT_PIN_5, _(""), wxPoint(600, 280), wxSize(45, 19), wxTE_READONLY, wxDefaultValidator, _("txt_pin_5"));

	txt_pin_4 = new wxTextCtrl(this, ID_TXT_PIN_4, _(""), wxPoint(600, 250), wxSize(45, 19), wxTE_READONLY, wxDefaultValidator, _("txt_pin_4"));

	txt_pin_3 = new wxTextCtrl(this, ID_TXT_PIN_3, _(""), wxPoint(600, 220), wxSize(45, 19), wxTE_READONLY, wxDefaultValidator, _("txt_pin_3"));

	txt_pin_2 = new wxTextCtrl(this, ID_TXT_PIN_2, _(""), wxPoint(600, 190), wxSize(45, 19), wxTE_READONLY, wxDefaultValidator, _("txt_pin_2"));

	WxStaticText14 = new wxStaticText(this, ID_WXSTATICTEXT14, _("PIO1_16"), wxPoint(540, 371), wxDefaultSize, 0, _("WxStaticText14"));

	WxStaticText13 = new wxStaticText(this, ID_WXSTATICTEXT13, _("PIO0_19"), wxPoint(540, 341), wxDefaultSize, 0, _("WxStaticText13"));

	WxStaticText12 = new wxStaticText(this, ID_WXSTATICTEXT12, _("PIO0_18"), wxPoint(540, 311), wxDefaultSize, 0, _("WxStaticText12"));

	WxStaticText11 = new wxStaticText(this, ID_WXSTATICTEXT11, _("PIO0_17"), wxPoint(540, 281), wxDefaultSize, 0, _("WxStaticText11"));

	WxStaticText10 = new wxStaticText(this, ID_WXSTATICTEXT10, _("PIO0_16"), wxPoint(540, 251), wxDefaultSize, 0, _("WxStaticText10"));

	WxStaticText9 = new wxStaticText(this, ID_WXSTATICTEXT9, _("PIO0_15"), wxPoint(540, 221), wxDefaultSize, 0, _("WxStaticText9"));

	WxStaticText8 = new wxStaticText(this, ID_WXSTATICTEXT8, _("PIO1_22"), wxPoint(540, 191), wxDefaultSize, 0, _("WxStaticText8"));

	WxStaticText7 = new wxStaticText(this, ID_WXSTATICTEXT7, _("PIO1_14"), wxPoint(540, 161), wxDefaultSize, 0, _("WxStaticText7"));

	txt_pin_1 = new wxTextCtrl(this, ID_TXT_PIN_1, _(""), wxPoint(600, 160), wxSize(45, 19), wxTE_READONLY, wxDefaultValidator, _("txt_pin_1"));

	WxStaticText6 = new wxStaticText(this, ID_WXSTATICTEXT6, _("Select Slave"), wxPoint(189, 311), wxDefaultSize, 0, _("WxStaticText6"));

	wxArrayString arrayStringFor_cmb_recover_config;
	cmb_recover_config = new wxComboBox(this, ID_CMB_RECOVER_CONFIG, _(""), wxPoint(153, 336), wxSize(145, 23), arrayStringFor_cmb_recover_config, wxCB_DROPDOWN | wxCB_READONLY | wxCB_SORT, wxDefaultValidator, _("cmb_recover_config"));

	btn_recover_config = new wxButton(this, ID_BTN_RECOVER_CONFIG, _("Recover Config."), wxPoint(30, 335), wxSize(91, 25), 0, wxDefaultValidator, _("btn_recover_config"));

	WxStaticText5 = new wxStaticText(this, ID_WXSTATICTEXT5, _("Introduce Slave name"), wxPoint(155, 240), wxDefaultSize, 0, _("WxStaticText5"));

	txt_introduce_slave = new wxTextCtrl(this, ID_TXT_INTRODUCE_SLAVE, _(""), wxPoint(153, 266), wxSize(121, 19), wxTE_PROCESS_ENTER, wxDefaultValidator, _("txt_introduce_slave"));

	btn_search_slave = new wxButton(this, ID_BTN_SEARCH_SLAVE, _("Search Slave"), wxPoint(30, 263), wxSize(75, 25), 0, wxDefaultValidator, _("btn_search_slave"));

	btn_send_frame = new wxButton(this, ID_BTN_SEND_FRAME, _("Send Frame"), wxPoint(386, 107), wxSize(75, 25), 0, wxDefaultValidator, _("btn_send_frame"));

	btn_load_bbdd = new wxButton(this, ID_BTN_LOAD_BBDD, _("Load BBDD"), wxPoint(385, 69), wxSize(83, 25), 0, wxDefaultValidator, _("btn_load_bbdd"));

	btn_connect_com = new wxButton(this, ID_BTN_CONNECT_COM, _("Connect COM"), wxPoint(385, 31), wxSize(82, 25), 0, wxDefaultValidator, _("btn_connect_com"));

	WxStaticText4 = new wxStaticText(this, ID_WXSTATICTEXT4, _("Hyperterminal"), wxPoint(150, 8), wxDefaultSize, 0, _("WxStaticText4"));

	hyperterminal = new wxRichTextCtrl(this, ID_HYPERTERMINAL, _(""), wxPoint(29, 32), wxSize(321, 130), wxRE_READONLY | wxRE_MULTILINE, wxDefaultValidator, _("hyperterminal"));
	hyperterminal->SetMaxLength(0);
	hyperterminal->SetFocus();
	hyperterminal->SetInsertionPointEnd();

	WxStaticText3 = new wxStaticText(this, ID_WXSTATICTEXT3, _("Data Selection"), wxPoint(380, 168), wxDefaultSize, 0, _("WxStaticText3"));

	WxStaticText2 = new wxStaticText(this, ID_WXSTATICTEXT2, _("Command Selection"), wxPoint(208, 168), wxDefaultSize, 0, _("WxStaticText2"));

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, _("Slave Selection"), wxPoint(65, 168), wxDefaultSize, 0, _("WxStaticText1"));

	wxArrayString arrayStringFor_cmb_data;
	cmb_data = new wxComboBox(this, ID_CMB_DATA, _(""), wxPoint(350, 195), wxSize(145, 23), arrayStringFor_cmb_data, wxCB_DROPDOWN | wxCB_READONLY | wxCB_SORT, wxDefaultValidator, _("cmb_data"));

	wxArrayString arrayStringFor_cmb_command;
	cmb_command = new wxComboBox(this, ID_CMB_COMMAND, _(""), wxPoint(190, 195), wxSize(145, 23), arrayStringFor_cmb_command, wxCB_DROPDOWN | wxCB_READONLY | wxCB_SORT, wxDefaultValidator, _("cmb_command"));

	wxArrayString arrayStringFor_cmb_slave_address;
	cmb_slave_address = new wxComboBox(this, ID_CMB_SLAVE_ADDRESS, _(""), wxPoint(30, 195), wxSize(145, 23), arrayStringFor_cmb_slave_address, wxCB_DROPDOWN | wxCB_READONLY | wxCB_SORT, wxDefaultValidator, _("cmb_slave_address"));

	SetTitle(_("RadioTransceiver"));
	SetIcon(wxNullIcon);
	SetSize(8,8,700,450);
	Center();
	
	////GUI Items Creation End
}

void RadioTransceiverDlg::OnClose(wxCloseEvent& /*event*/)
{
	Destroy();
}

////////////////////COM funciones///////////////////////////

//-------------------------------------------------------------------------
//  int AbrirCOM(const char* COM_PORT)
//
//  DESCRIPCION:
//      Esta funcin es empleada para abrir un puerto serie del PC
//
//  ARGUMENTOS:
//      Puerto COM que se desea abrir
//-------------------------------------------------------------------------

int RadioTransceiverDlg::AbrirCOM(const char* COM_PORT)
{
    idComDev = CreateFileA(COM_PORT, GENERIC_READ | GENERIC_WRITE,
                        0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
                        
    if(idComDev ==INVALID_HANDLE_VALUE)
    {
        //hyperterminal->AppendText(wxString::Format("Error 1, puerto serie: %d\n", GetLastError()));
        return false;
    }
    
    dcb.DCBlength=sizeof(dcb);
    
    if(!GetCommState(idComDev, &dcb))
    { 
        //hyperterminal->AppendText(wxString::Format("Error 2, puerto serie\n"));
        return false; 
    }
    
    dcb.BaudRate = (DWORD) CBR_115200;
    dcb.ByteSize = (BYTE) 8;
    dcb.Parity   = (BYTE) NOPARITY;
    dcb.StopBits = (BYTE) ONESTOPBIT;
    
    if(!SetCommState(idComDev, &dcb))
    { 
        //hyperterminal->AppendText(wxString::Format("Error 3, SetCommStatus\n"));
        return false;
    }
    
    COMMTIMEOUTS timeouts={0};
    
    //The maximum time allowed to elapse before the arrival of the next byte on 
    //the communications line, in milliseconds.If the interval between the arrival 
    //of any two bytes exceeds this amount, the ReadFile operation is completed and 
    //any buffered data is returned
    timeouts.ReadIntervalTimeout = 50;
    
    //A constant used to calculate the total time-out period for read operations, 
    //in milliseconds. For each read operation, this value is added to the product 
    //of the ReadTotalTimeoutMultiplier member and the requested number of bytes.
    timeouts.ReadTotalTimeoutConstant = 50;
    
    //The multiplier used to calculate the total time-out period for read operations, 
    //in milliseconds. For each read operation, this value is multiplied by the 
    //requested number of bytes to be read.
    timeouts.ReadTotalTimeoutMultiplier = 10;
    
    //Idem as ReadTotalTimeoutConstant
    timeouts.WriteTotalTimeoutConstant = 50;
    
    //Idem as ReadTotalTimeoutMultiplier
    timeouts.WriteTotalTimeoutMultiplier = 10;
    
    if(!SetCommTimeouts(idComDev,&timeouts))
    { 
        //hyperterminal->AppendText(wxString::Format("Error 4, timeouts\n"));
        return false; 
    }  
    return true;
}

//-------------------------------------------------------------------------
//  void CerrarCOM()
//
//  DESCRIPCION:
//      Esta funcin es empleada para cerrar un puerto serie del PC
//
//  ARGUMENTOS:
//      No tiene
//-------------------------------------------------------------------------

void RadioTransceiverDlg::CerrarCOM()
{
    CloseHandle(idComDev);
}

//-------------------------------------------------------------------------
//  void EscribirCOM(const char* buffer)
//
//  DESCRIPCION:
//      Esta funcin es empleada para escribir en un puerto serie del PC
//
//  ARGUMENTOS:
//      Buffer donde se encuentran los caracteres a escribir
//-------------------------------------------------------------------------

void RadioTransceiverDlg::EscribirCOM(const char* buffer)  
{
    DWORD numbytes = 0;
    if(!WriteFile(idComDev, buffer, PCFRAME, &numbytes, NULL))
        hyperterminal->AppendText(wxString::Format("<-Error en la escritura\n")); 
    //else
        //hyperterminal->AppendText(wxString::Format("<-Escritura con exito\n"));          
}

//-------------------------------------------------------------------------
//  void LeerCOM(char* buffer, int size) 
//
//  DESCRIPCION:
//      Esta funcin es empleada para leer de un puerto serie del PC
//
//  ARGUMENTOS:
//      Buffer donde se almacenarn los caracteres y tamao de la lectura
//-------------------------------------------------------------------------

void RadioTransceiverDlg::LeerCOM(char* buffer, int size)    
{
    DWORD numbytes = 0;
    if(!ReadFile(idComDev, buffer, size, &numbytes, NULL))
        hyperterminal->AppendText(wxString::Format("->Error en la lectura\n"));
    //else
        //hyperterminal->AppendText(wxString::Format("->Lectura con exito\n"));
}

//-------------------------------------------------------------------------
//  int IniciarCOM(char* path) 
//
//  DESCRIPCION:
//      Esta funcin es empleada para localizar un puerto serie del PC habilitado
//
//  ARGUMENTOS:
//      Variable donde se almacenar el path del COM
//-------------------------------------------------------------------------

int RadioTransceiverDlg::IniciarCOM(char* path)     
{
    int i;
    for (i=20;i>1;i--) 
    {
        sprintf(path,"\\\\.\\COM%d",i);    
        if(AbrirCOM(path))
            goto L1;
        CerrarCOM();
    }
    hyperterminal->AppendText(wxString::Format("->Puerto serie no encontrado\n"));
    return 0;
L1:  
    CerrarCOM(); 
    hyperterminal->AppendText(wxString::Format("->Puerto serie: %d\nVelocidad: 115200 baudios\n",i));
    return 1;
}

//-------------------------------------------------------------------------
//  void strcpy_sure(char *buff, char *command, char len)
//
//  DESCRIPCION:
//      Esta funcin es empleada para copiar datos entre dos bufferes
//
//  ARGUMENTOS:
//      Buffer origen, buffer destino y nmero de caracteres a copiar
//-------------------------------------------------------------------------

void RadioTransceiverDlg::strcpy_sure(char *buff, char *command, char len)
{
	while(len--)
		*buff++ = *command++;
}

//-------------------------------------------------------------------------
//  void initialize_vector(char *buff, int length)
//
//  DESCRIPCION:
//      Esta funcin es empleada para inicializar el contenido de un vector
//
//  ARGUMENTOS:
//      Buffer a inicializar y longitud del vector a inicializar
//-------------------------------------------------------------------------

void RadioTransceiverDlg::initialize_vector(char *buff, int length)
{
	while(length--)
		*buff++ = 0;	
}

//-------------------------------------------------------------------------
//  int tx_rx_frame(char *address_slave, char *command, char *data)
//
//  DESCRIPCION:
//      Esta funcin es empleada para transmitir y recibir una orden
//
//  ARGUMENTOS:
//      Mdulo esclavo destino, orden a realizar y datos a enviar
//-------------------------------------------------------------------------

int RadioTransceiverDlg::tx_rx_frame(char *address_slave, char *command, char *data)
{
    int j;
    
    initialize_vector(buf_RX,SIZE_BUFF);
    initialize_vector(pc_frame,PCFRAME);
    
    strcpy_sure(pc_frame,address_slave,ADDRESS_LENGTH);
    strcpy_sure(&pc_frame[4],command,1);
    strcpy_sure(&pc_frame[5],data,6);
    strcpy_sure(&pc_frame[11],&EOFr,1);
    
    //for(j=0;j<12;j++)
      // hyperterminal->AppendText(wxString::Format("Caracter %c\n",pc_frame[j]));

    EscribirCOM(pc_frame);

    LeerCOM(buf_RX,SIZE_BUFF);  
  
    if(!strcmp(buf_RX,"Error") || (buf_RX[4] != pc_frame[4]) || !strlen(buf_RX)) 
        return 1; //Si se ley error o '0' o el comando solicitado y el recibido son distintos
    else
    {
        hyperterminal->AppendText(wxString::Format("\nMensaje recibido : "));
        for(j=0;j<36;j++)  //Limitamos el nmero de caracteres a mostrar por el terminal
        {
            if (buf_RX[j] == 0x00) //En caso de que sea NULL representamos espacio
                hyperterminal->AppendText(wxString::Format(" "));
            else    
                hyperterminal->AppendText(wxString::Format("%c",buf_RX[j]));
        }
        return 0;
    }
}

////////////////////COM funciones///////////////////////////

////////////////////SLAVE funciones///////////////////////////

//-------------------------------------------------------------------------
//  char translate_name_number(const char* string, char* matrix)
//
//  DESCRIPCION:
//      Esta funcin es empleada para traducir de un nombre a un nmero
//
//  ARGUMENTOS:
//      Nombre a traducir y matriz que contiene los nombres
//-------------------------------------------------------------------------

char RadioTransceiverDlg::translate_name_number(const char* string, char* matrix)
{
    char i=0;
    
    while(*matrix)
    {
        if(!strcmp(matrix,string))
            return i; 
        matrix+=12;     //Siguiente fila de la matriz
        i++;             
    }
}

//-------------------------------------------------------------------------
//  void show_slave(const Type_slave *slave)
//
//  DESCRIPCION:
//      Esta funcin es empleada para mostrar los esclavos en la interfaz grfica
//
//  ARGUMENTOS:
//      Esclavo cuyo nombre se desea mostrar
//-------------------------------------------------------------------------

void RadioTransceiverDlg::show_slave(const Type_slave *slave)
{
    cmb_slave_address->Append(slave->name);
    cmb_recover_config->Append(slave->name);
    cmb_slave_view->Append(slave->name);
}

//-------------------------------------------------------------------------
//  int detect_slave(Type_slave *slave, const char *name)
//
//  DESCRIPCION:
//      Esta funcin es empleada para detectar la presencia de un mdulo
//
//  ARGUMENTOS:
//      Nombre del esclavo a localizar y estructura para almacenarlo
//-------------------------------------------------------------------------

int RadioTransceiverDlg::detect_slave(Type_slave *slave, const char *name)
{
    char broadcast_address[4]={0};
    char contador;

    for(contador = 0; contador <=10;contador++)
    {
        if(!tx_rx_frame(broadcast_address,command_number[BROADCAST],(char*)"no_use"))
            goto L1;
    }
    hyperterminal->AppendText(wxString::Format("\n->Error, the operation couldn't be set\n"));
    return 1;   //Hubo un error
L1:
    strcpy(slave->name, name); //Mostramos el nuevo esclavo en la interfaz grfica
    strcpy_sure(slave->address, &buf_RX[5],4); 
    cmb_slave_address->Append(slave->name);
    cmb_slave_view->Append(slave->name); 
    cmb_recover_config->Append(slave->name);
    return 0;
}

//-------------------------------------------------------------------------
//  int temperature_slave(char *slave_address)
//
//  DESCRIPCION:
//      Esta funcin es empleada para leer la temperatura de un mdulo
//
//  ARGUMENTOS:
//      Direccin del esclavo cuya temperatura se desea medir
//-------------------------------------------------------------------------

int RadioTransceiverDlg::temperature_slave(char *slave_address)
{
    char temperature[3]={0};    //3 digitos hexadecimales
    float value;
    char j;
    char contador;
    
    for(contador = 0;contador <=10; contador++)
    {
        if(!tx_rx_frame(slave_address,command_number[TEMPERATURE],(char*)"no_use"))
            goto L1;
    }
    hyperterminal->AppendText(wxString::Format("\n->Error, the operation couldn't be set\n"));
    return 1;
L1:  
    strcpy_sure(temperature,&buf_RX[8],3);
        
    for(j=0;j<3;j++)    //Convertimos los dgitos de ASCII a binario
	{
        if((temperature[j]>=48) && (temperature[j]<=57))
			temperature[j] = temperature[j]-48;
		if((temperature[j]>=65) && (temperature[j]<=70))
			temperature[j] = temperature[j]-55;     
	}
	    
    value = temperature[0]*16*16 + temperature[1]*16 + temperature[2];
    value = (value*3.3)/1024;       //ADC del micro es de 10bits de resolucin
    value = (value - 0.75)/0.00243; //Curva de transferencia del sensor
        
    txt_temperature->Clear();
    txt_temperature->AppendText(wxString::Format("%.2f",value));
    return 0;
}

//-------------------------------------------------------------------------
//  void restablish_config(Type_slave *slave)
//
//  DESCRIPCION:
//      Esta funcin es empleada para reestablecer la configuracin de un mdulo
//
//  ARGUMENTOS:
//      Estructura del esclavo cuya configuracin se desea recuperar
//-------------------------------------------------------------------------

void RadioTransceiverDlg::restablish_config(Type_slave *slave)
{
    char i;
    char state[6] = {0};
    char contador;
    
    for(i=0;i<4;i++)    //Los 4 pines que son salida
    {
       if(slave->pin_state[i] == '1')
            state[5] |= (1<<(7-i));    
    } 
    for(contador = 0;contador <=10; contador++)
    {
        if(!tx_rx_frame(slave->address,command_number[RECOVERCONFIG],state))
            goto L1;
    }
    hyperterminal->AppendText(wxString::Format("\n->Error, the operation couldn't be set\n"));      
    hyperterminal->AppendText(wxString::Format("\n->Recover configuration couldn't be set\n"));
    return;
L1:
    hyperterminal->AppendText(wxString::Format("\n->Recover configuration completed\n"));
    slave_pin_view(slave);
}

//-------------------------------------------------------------------------
//  int slave_pin_view(Type_slave *slave)
//
//  DESCRIPCION:
//      Esta funcin es empleada para leer el estado de los pines de un mdulo
//
//  ARGUMENTOS:
//      Estructura del esclavo cuyos pines se desean leer
//-------------------------------------------------------------------------

int RadioTransceiverDlg::slave_pin_view(Type_slave *slave)
{
    char port;
    char* ptr_port = &port;
    char contador;

    txt_pin_1->Clear();
    txt_pin_2->Clear();
    txt_pin_3->Clear();
    txt_pin_4->Clear();
    txt_pin_5->Clear();
    txt_pin_6->Clear();
    txt_pin_7->Clear();
    txt_pin_8->Clear(); 
    
    for(contador = 0;contador <=10;contador++)
    {
        if(!tx_rx_frame(slave->address,command_number[READPINS],(char*)"no_use"))
            goto L1;
    }
    hyperterminal->AppendText(wxString::Format("\n->Error, the operation couldn't be set\n"));
    return 1; 
L1:
    hyperterminal->AppendText(wxString::Format("\n->Read Pins measured successfully\n"));
    
    strcpy_sure(ptr_port,&buf_RX[10],1);
    
    //En base a lo recibido actuamos
    
    (port&0x01)?txt_pin_8->AppendText("SET"):txt_pin_8->AppendText("RESET");
    (port&0x01)?slave->pin_state[7] = '1':slave->pin_state[7] = '0';

    (port&0x02)?txt_pin_7->AppendText("SET"):txt_pin_7->AppendText("RESET");
    (port&0x02)?slave->pin_state[6] = '1':slave->pin_state[6] = '0';

    (port&0x04)?txt_pin_6->AppendText("SET"):txt_pin_6->AppendText("RESET");
    (port&0x04)?slave->pin_state[5] = '1':slave->pin_state[5] = '0';

    (port&0x08)?txt_pin_5->AppendText("SET"):txt_pin_5->AppendText("RESET");
    (port&0x08)?slave->pin_state[4] = '1':slave->pin_state[4] = '0';
        
    (port&0x10)?txt_pin_4->AppendText("SET"):txt_pin_4->AppendText("RESET");
    (port&0x10)?slave->pin_state[3] = '1':slave->pin_state[3] = '0';

    (port&0x20)?txt_pin_3->AppendText("SET"):txt_pin_3->AppendText("RESET");
    (port&0x20)?slave->pin_state[2] = '1':slave->pin_state[2] = '0';
        
    (port&0x40)?txt_pin_2->AppendText("SET"):txt_pin_2->AppendText("RESET");
    (port&0x40)?slave->pin_state[1] = '1':slave->pin_state[1] = '0';

    (port&0x80)?txt_pin_1->AppendText("SET"):txt_pin_1->AppendText("RESET");
    (port&0x80)?slave->pin_state[0] = '1':slave->pin_state[0] = '0';
                            
    return 0;
}

////////////////////SLAVE funciones///////////////////////////

////////////////////SLAVE LIST funciones///////////////////////////

//-------------------------------------------------------------------------
//  void slave_list(const Type_slave_list *list_slave)
//
//  DESCRIPCION:
//      Esta funcin es empleada para actualizar la lista de todos los esclavos
//
//  ARGUMENTOS:
//      Estructura de la lista de esclavos
//-------------------------------------------------------------------------

void RadioTransceiverDlg::slave_list(const Type_slave_list *list_slave)
{
	int i;
    
    //hyperterminal->AppendText(wxString::Format("Number of slaves: %d\n\n",list_slave->number));

	if(list_slave->number == 0)
	   hyperterminal->AppendText(wxString::Format("Slave list is empty.\n\n"));
	   
    cmb_slave_address->Clear();
    cmb_recover_config->Clear();
    cmb_slave_view->Clear();

	for(i=0;i<list_slave->number;i++)
       show_slave(&list_slave->list[i]);
}

//-------------------------------------------------------------------------
//  int duplicate_slave_name(const Type_slave_list *list_slave, const char* slave_name)
//
//  DESCRIPCION:
//      Esta funcin es empleada para comprobar la duplicidad de nombres
//
//  ARGUMENTOS:
//      Estructura de la lista de esclavos y nombre del esclavo a comprobar
//-------------------------------------------------------------------------

int RadioTransceiverDlg::duplicate_slave_name(const Type_slave_list *list_slave, const char* slave_name)
{
    int i;
    
    for(i=0;i<list_slave->number;i++)
    {
        if(!strcmp(list_slave->list[i].name, slave_name))
            return 1;
    }   
    return 0;  
}

//-------------------------------------------------------------------------
//  void new_slave(Type_slave_list *list_slave)
//
//  DESCRIPCION:
//      Esta funcin es empleada para aadir un esclavo nuevo
//
//  ARGUMENTOS:
//      Estructura de la lista de esclavos
//-------------------------------------------------------------------------

void RadioTransceiverDlg::new_slave(Type_slave_list *list_slave)
{   
    if(duplicate_slave_name(list_slave, txt_introduce_slave->GetLineText(0)))
    {
        hyperterminal->AppendText(wxString::Format("\nName of the slave exists on BBDD yet!!!\n"));
        return;
    }
    
    if(detect_slave(&list_slave->list[list_slave->number], txt_introduce_slave->GetLineText(0)))
        return;
    else
    {  
        list_slave->number++;
        hyperterminal->AppendText(wxString::Format("\nSlave added successfully\n"));
    }
}

//-------------------------------------------------------------------------
//  void delete_slave(Type_slave_list *list_slave, const char* slave_name)
//
//  DESCRIPCION:
//      Esta funcin es empleada para eliminar un esclavo de la BBDD
//
//  ARGUMENTOS:
//      Estructura de la lista de esclavos y nombre del esclavo a eliminar
//-------------------------------------------------------------------------

void RadioTransceiverDlg::delete_slave(Type_slave_list *list_slave, const char* slave_name)
{
    int i;
    
    for(i=0;i<list_slave->number;i++)
    {
        if(!strcmp(list_slave->list[i].name, slave_name))
            break;
    }   
    
    list_slave->number--;
    
    for(i;i<list_slave->number;i++)
        list_slave->list[i] = list_slave->list[i+1];
        
    slave_list(list_slave);
}

//-------------------------------------------------------------------------
//  Type_slave* const search_slave(Type_slave_list *list_slave, const char* slave_name)
//
//  DESCRIPCION:
//      Esta funcin es empleada para localizar la estructura de un esclavo
//
//  ARGUMENTOS:
//      Estructura de la lista de esclavos y nombre del esclavo a buscar
//-------------------------------------------------------------------------

RadioTransceiverDlg::Type_slave* const RadioTransceiverDlg::search_slave(Type_slave_list *list_slave, const char* slave_name)
{
    int i;
    
    for(i=0;i<list_slave->number;i++)
    {
        if(!strcmp(list_slave->list[i].name, slave_name))
            return &list_slave->list[i];
    }  
}

//-------------------------------------------------------------------------
//  void load_data_slaves(Type_slave_list *list_slave)
//
//  DESCRIPCION:
//      Esta funcin es empleada para cargar la BBDD de esclavos
//
//  ARGUMENTOS:
//      Estructura de la lista de esclavos donde almacenar los mismos
//-------------------------------------------------------------------------

void RadioTransceiverDlg::load_data_slaves(Type_slave_list *list_slave)
{
	int fd,i;
    // Compruebo existencia de archivo y de registros
    list_slave->number = num_reg_slaves("slaves.dat",sizeof(Type_slave));

	if(list_slave->number)
    {
       hyperterminal->AppendText(wxString::Format("\nNumber of slaves: %d\n\n",list_slave->number));

       if(list_slave->number >= MAX_SLAVE)
       {
            hyperterminal->AppendText(wxString::Format("There is no enough registers for listing.\n"));
            return;
       }
        fd = open("slaves.dat", O_RDONLY);
    
        if(fd == -1)
        {
            hyperterminal->AppendText(wxString::Format("Error opening slaves.dat\n"));
            hyperterminal->AppendText(wxString::Format("%s\n", strerror(errno)));
            return;
        }
        
        for(i=0;i<list_slave->number;i++)
            read(fd, &list_slave->list[i], sizeof(Type_slave));

        close(fd);
    } 
    else
        hyperterminal->AppendText(wxString::Format("There is any slave on BBDD\n"));
}

//-------------------------------------------------------------------------
//  void save_data_slaves(const Type_slave_list *list_slave)
//
//  DESCRIPCION:
//      Esta funcin es empleada para guardar la BBDD de esclavos
//
//  ARGUMENTOS:
//      Estructura de la lista de esclavos que se desea almacenar 
//-------------------------------------------------------------------------

void RadioTransceiverDlg::save_data_slaves(const Type_slave_list *list_slave)
{
	int fd,i;
                                  ///////access/////      ////Permission///
    fd = open("slaves.dat", O_WRONLY | O_CREAT | O_TRUNC, S_IRUSR | S_IWUSR); 
    //O_WRONLY -> Solamente se permite operaciones de escritura
    //O_CREAT  -> Crea el archivo si no exista
    //O_TRUNC  -> Si el fichero existe, borra todo su contenido
                                                                    
    //Permisos requeridos si el fichero es creado, ignorado de otro modo
    //S_IRUSR  -> Propietario puede leer
    //S_IWUSR  -> Propietario puede escribir
    
    if(fd == -1)
    {
        hyperterminal->AppendText(wxString::Format("Error opening slaves.dat\n"));
        hyperterminal->AppendText(wxString::Format("%s\n", strerror(errno)));
        return;
    }

    for(i=0;i<list_slave->number;i++)
        write(fd, &list_slave->list[i], sizeof(Type_slave));

    close(fd);
}

//-------------------------------------------------------------------------
//  int num_reg_slaves(const char *bbdd,int size_reg)
//
//  DESCRIPCION:
//      Esta funcin es empleada para calcular el nmero de esclavos en la 
//      BBDD
//
//  ARGUMENTOS:
//      Nombre del fichero que contiene los datos y tamao de un esclavo 
//-------------------------------------------------------------------------

int RadioTransceiverDlg::num_reg_slaves(const char *bbdd,int size_reg)
{
	int fd;
	int nbytes,nreg;

	fd = open(bbdd, O_RDONLY);

    if(fd == -1)
    {
        hyperterminal->AppendText(wxString::Format("Error opening slaves.dat\n"));
        hyperterminal->AppendText(wxString::Format("%s\n", strerror(errno)));
        return 0;
    }

	lseek(fd,0,SEEK_END);  //The file offset shall be set to the size of the file
	nbytes = tell(fd);     
    //Reports the offset of the current byte relative to the beginning 
    //of the file associated with the file descriptor.(The value obtained by 
    //lseek function)
	close(fd);
	nreg=nbytes/size_reg;

	return nreg;
}

////////////////////SLAVE LIST funciones///////////////////////////

////////////////////GRAPHIC INTERFACE funciones///////////////////////////

/*
 * cmb_slave_addressSelected
 */
 
void RadioTransceiverDlg::cmb_slave_addressSelected(wxCommandEvent& event )
{
	if(strlen(cmb_command->GetStringSelection().mb_str()) &&
       strlen(cmb_data->GetStringSelection().mb_str()) &&
       strlen(cmb_slave_address->GetStringSelection().mb_str()))
            btn_send_frame->Enable(true);
	       //hyperterminal->AppendText(wxString::Format("hay seleccion\n"));
	else
	   btn_send_frame->Disable();
	   //hyperterminal->AppendText(wxString::Format("No hay seleccion\n"));
}

/*
 * cmb_dataSelected
 */
 
void RadioTransceiverDlg::cmb_dataSelected(wxCommandEvent& event )
{
	if(strlen(cmb_command->GetStringSelection().mb_str()) &&
       strlen(cmb_data->GetStringSelection().mb_str()) &&
       strlen(cmb_slave_address->GetStringSelection().mb_str()))
            btn_send_frame->Enable(true);
	       //hyperterminal->AppendText(wxString::Format("hay seleccion\n"));
	else
	   btn_send_frame->Disable();
	   //hyperterminal->AppendText(wxString::Format("No hay seleccion\n"));	
}

/*
 * cmb_commandSelected
 */
 
void RadioTransceiverDlg::cmb_commandSelected(wxCommandEvent& event )
{
	if(strlen(cmb_command->GetStringSelection().mb_str()) &&
       strlen(cmb_data->GetStringSelection().mb_str()) &&
       strlen(cmb_slave_address->GetStringSelection().mb_str()))
            btn_send_frame->Enable(true);
	       //hyperterminal->AppendText(wxString::Format("hay seleccion\n"));
	else
	   btn_send_frame->Disable();
	   //hyperterminal->AppendText(wxString::Format("No hay seleccion\n"));
}

/*
 * load_bbddClick
 */
 
void RadioTransceiverDlg::btn_load_bbddClick(wxCommandEvent& event)
{  
    button_bbdd = 1;
    btn_load_bbdd->Disable();
    btn_save_bbdd->Enable(true); 
    
	load_data_slaves(&list_slave);
	slave_list(&list_slave);
    
    //Aadimos los pines que son salida
	cmb_data->Append(pin_name[0]);
	cmb_data->Append(pin_name[1]);
	cmb_data->Append(pin_name[2]);
	cmb_data->Append(pin_name[3]);

	//Aadimos los comandos para los pines que son salida
	cmb_command->Append(command_name[SETPIN]);
	cmb_command->Append(command_name[RESETPIN]);
}

/*
 * btn_save_bbddClick
 */
 
void RadioTransceiverDlg::btn_save_bbddClick(wxCommandEvent& event)
{
	save_data_slaves(&list_slave); 
	hyperterminal->AppendText(wxString::Format("\nBBDD saved successfully\n"));
}

/*
 * connect_comClick
 */
 
void RadioTransceiverDlg::btn_connect_comClick(wxCommandEvent& event)
{
	if(IniciarCOM(path_com))
    {             
        AbrirCOM(path_com);
        btn_connect_com->Disable();
        btn_close_com->Enable(true);  
        
        if(!button_bbdd)
            btn_load_bbdd->Enable(true);
        
        btn_recover_config->Enable(true); 
        btn_search_slave->Enable(true);
        btn_delete_slave->Enable(true);
        btn_temperature->Enable(true);
        cmb_slave_address->Enable(true);
        cmb_command->Enable(true);
        cmb_data->Enable(true); 
        cmb_slave_view->Enable(true); 
        cmb_recover_config->Enable(true);
        
        if(strlen(cmb_command->GetStringSelection().mb_str()) &&
           strlen(cmb_data->GetStringSelection().mb_str()) &&
           strlen(cmb_slave_address->GetStringSelection().mb_str()))
           btn_send_frame->Enable(true);
	       //hyperterminal->AppendText(wxString::Format("hay seleccion\n"));
	    else
	       btn_send_frame->Disable();
	   //hyperterminal->AppendText(wxString::Format("NO hay seleccion\n"));
    }
}

/*
 * btn_close_comClick
 */
 
void RadioTransceiverDlg::btn_close_comClick(wxCommandEvent& event)
{
	CerrarCOM();
	hyperterminal->AppendText(wxString::Format("->Puerto COM cerrado"));
	
	btn_close_com->Disable();      //Desactivamos los botones
	btn_connect_com->Enable(true);
	btn_recover_config->Disable(); 
    btn_search_slave->Disable(); 
    btn_delete_slave->Disable();
    btn_send_frame->Disable();
    btn_temperature->Disable();
    cmb_slave_address->Disable(); 
    cmb_command->Disable(); 
    cmb_data->Disable(); 
    cmb_slave_view->Disable(); 
    cmb_recover_config->Disable();
}

/*
 * btn_send_frameClick
 */
 
void RadioTransceiverDlg::btn_send_frameClick(wxCommandEvent& event)
{
    char number_pin,number_command; 
    char contador;
    Type_slave* slave_struct;
    
    slave_struct = search_slave(&list_slave, cmb_slave_address->GetStringSelection().mb_str());
    
    number_pin = translate_name_number((cmb_data->GetStringSelection().mb_str()),(char*)pin_name);   
    number_command = translate_name_number((cmb_command->GetStringSelection().mb_str()),(char*)command_name); 
       
    //hyperterminal->AppendText(wxString::Format("->Slave name %s\n",slave_struct->name));
	//hyperterminal->AppendText(wxString::Format("->Pin name %s\n",cmb_data->GetStringSelection().mb_str()));
    //hyperterminal->AppendText(wxString::Format("->Command name %s\n",cmb_command->GetStringSelection().mb_str()));

    for(contador = 0;contador <= 10; contador++)
    {
        if(!tx_rx_frame(slave_struct->address,command_number[number_command], pin_number[number_pin]))
            goto L1;
    }
    hyperterminal->AppendText(wxString::Format("\n->Error, the operation couldn't be set\n"));
    return;
L1:  
    if(!strcmp(command_number[number_command],command_number[SETPIN]))
    {
        slave_struct->pin_state[number_pin] = '1';
        hyperterminal->AppendText(wxString::Format("\n->Pin %s SET it successfully\n", &pin_name[number_pin][0]));
    } 
    else if(!strcmp(command_number[number_command],command_number[RESETPIN]))
    {
        slave_struct->pin_state[number_pin] = '0';
        hyperterminal->AppendText(wxString::Format("\n->Pin %s RESET it successfully\n", &pin_name[number_pin][0]));
    }     
    slave_pin_view(slave_struct);   
}

/*
 * btn_search_slaveClick
 */
 
void RadioTransceiverDlg::btn_search_slaveClick(wxCommandEvent& event)
{
	if(strlen(txt_introduce_slave->GetLineText(0)))
	   new_slave(&list_slave);
	else
	   hyperterminal->AppendText(wxString::Format("There is any name introduced\n"));
}

/*
 * btn_delete_slaveClick
 */
 
void RadioTransceiverDlg::btn_delete_slaveClick(wxCommandEvent& event)
{
    if(strlen(cmb_recover_config->GetStringSelection().mb_str()))
    {
        delete_slave(&list_slave,cmb_recover_config->GetStringSelection().mb_str());
        hyperterminal->AppendText(wxString::Format("Slave deleted successfully\n"));
    }   
    else
       hyperterminal->AppendText(wxString::Format("There is any slave selected\n")); 
}

/*
 * btn_recover_configClick
 */
 
void RadioTransceiverDlg::btn_recover_configClick(wxCommandEvent& event)
{
    if(strlen(cmb_recover_config->GetStringSelection().mb_str()))
        restablish_config(search_slave(&list_slave, cmb_recover_config->GetStringSelection().mb_str()));   
    else
       hyperterminal->AppendText(wxString::Format("There is any slave selected\n")); 
}

/*
 * cmb_slave_viewSelected
 */
 
void RadioTransceiverDlg::cmb_slave_viewSelected(wxCommandEvent& event )
{    
    if(slave_pin_view(search_slave(&list_slave, cmb_slave_view->GetStringSelection().mb_str())))
        hyperterminal->AppendText(wxString::Format("Read Pins couldn't be measured\n"));
}

/*
 * btn_temperatureClick
 */
 
void RadioTransceiverDlg::btn_temperatureClick(wxCommandEvent& event)
{
    Type_slave* slave_struct;
    	
    if(strlen(cmb_recover_config->GetStringSelection().mb_str()))
    {
        slave_struct = search_slave(&list_slave, cmb_recover_config->GetStringSelection().mb_str());
        if(temperature_slave(slave_struct->address))
            hyperterminal->AppendText(wxString::Format("Temperature couldn't be measured\n"));
        else
            hyperterminal->AppendText(wxString::Format("Temperature measured successfully\n"));
    }    
    else
       hyperterminal->AppendText(wxString::Format("There is any slave selected\n"));
}

////////////////////GRAPHIC INTERFACE funciones///////////////////////////

