///-----------------------------------------------------------------
///
/// @file      RadioTransceiverDlg.h
/// @author    user
/// Created:   08/02/2015 20:13:44
/// @section   DESCRIPTION
///            RadioTransceiverDlg class declaration
///
///------------------------------------------------------------------

#ifndef __RADIOTRANSCEIVERDLG_H__
#define __RADIOTRANSCEIVERDLG_H__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/dialog.h>
#else
	#include <wx/wxprec.h>
#endif

/////////////////////////COM.H//////////////////////////

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>

#include <fcntl.h>
#include <stdio.h>

#include "windows.h"

#define SIZE_BUFF 200

#define true 1
#define false 0

#define PCFRAME 12
#define ADDRESS_LENGTH 4

/////////////////////////COM.H//////////////////////////

/////////////////////////SLAVE.H//////////////////////////

#define MAX_SLAVE 1024

/////////////////////////SLAVE.H//////////////////////////

/////////////////////////SLAVE LIST.H//////////////////////////

#include <errno.h>
#include <sys/stat.h>

/////////////////////////SLAVE LIST.H//////////////////////////

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/textctrl.h>
#include <wx/button.h>
#include <wx/richtext/richtextctrl.h>
#include <wx/stattext.h>
#include <wx/combobox.h>
////Header Include End

////Dialog Style Start
#undef RadioTransceiverDlg_STYLE
#define RadioTransceiverDlg_STYLE wxCAPTION | wxSYSTEM_MENU | wxDIALOG_NO_PARENT | wxMINIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

class RadioTransceiverDlg : public wxDialog
{
	private:
		DECLARE_EVENT_TABLE();
		
		char path_com[1024];
		
		char button_bbdd;
		
		////////////////////COM variables///////////////////////////
		
		HANDLE idComDev; 
        DCB dcb;
        char pc_frame[PCFRAME];
        char EOFr;       //Caracter ASCII de Nueva Lnea (End Of Frame)
        char buf_RX[SIZE_BUFF];
        
        ////////////////////COM variables///////////////////////////
        
        ////////////////////SLAVE variables///////////////////////////
        typedef enum commands{READPINS=0,BROADCAST,SETPIN,
                              RESETPIN,TEMPERATURE,RECOVERCONFIG} Orders;
        Orders Commands; 
        
        typedef struct slave
        {
            char name[30];
            char address[5];  
            char pin_state[9];
        }Type_slave;
         
        char pin_name[9][12];
                       
        char pin_number[9][12];
        
        char command_name[255][12];
        
        char command_number[255][2];
        
        ////////////////////SLAVE variables///////////////////////////
        
        ////////////////////SLAVE LIST variables///////////////////////////
        
        typedef struct slave_list
        {
            int number;
            Type_slave list[MAX_SLAVE];  
        }Type_slave_list;
        
        Type_slave_list list_slave;
        
        ////////////////////SLAVE LIST variables///////////////////////////
		
	public:
		RadioTransceiverDlg(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("RadioTransceiver"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = RadioTransceiverDlg_STYLE);
		virtual ~RadioTransceiverDlg();
		void cmb_slave_addressSelected(wxCommandEvent& event );
		void cmb_dataSelected(wxCommandEvent& event );
		void cmb_commandSelected(wxCommandEvent& event );
		void cmb_slave_addressUpdated(wxCommandEvent& event );
		void cmb_slave_addressUpdateUI(wxUpdateUIEvent& event);
		void btn_load_bbddClick(wxCommandEvent& event);
		void btn_connect_comClick(wxCommandEvent& event);
		void btn_send_frameClick(wxCommandEvent& event);
		void btn_search_slaveClick(wxCommandEvent& event);
		void btn_recover_configClick(wxCommandEvent& event);
		void btn_close_comClick(wxCommandEvent& event);
		void btn_save_bbddClick(wxCommandEvent& event);
		void cmb_slave_viewSelected(wxCommandEvent& event );
		void btn_temperatureClick(wxCommandEvent& event);
		void btn_delete_slaveClick(wxCommandEvent& event);
		void Inicialization();
		
		////////////////////COM metodos///////////////////////////
		
        int AbrirCOM(const char* COM_PORT);
        void CerrarCOM();
        void EscribirCOM(const char* buffer) ;
        void LeerCOM(char* buffer, int size);
        int IniciarCOM(char* path);
        void strcpy_sure(char *buff, char *command, char len);
        void initialize_vector(char *buff, int length);
        int tx_rx_frame(char *address_slave, char *command, char *data);
        
        ////////////////////COM metodos///////////////////////////
        
        ////////////////////SLAVE metodos///////////////////////////
        
        void show_slave(const Type_slave *slave);
        int detect_slave(Type_slave *slave, const char *string);
        int temperature_slave(char *slave_address);
        char translate_name_number(const char *string, char *matrix);
        void restablish_config(Type_slave *slave);
        int slave_pin_view(Type_slave *slave);
        
        ////////////////////SLAVE metodos///////////////////////////
        
        ////////////////////SLAVE LIST metodos///////////////////////////
        
        void slave_list(const Type_slave_list *list);
        int duplicate_slave_name(const Type_slave_list *list, const char* name);
        void new_slave(Type_slave_list *list);
        void delete_slave(Type_slave_list *list, const char* name);
        Type_slave* const search_slave(Type_slave_list *list, const char* name);
        void load_data_slaves(Type_slave_list *list);
        void save_data_slaves(const Type_slave_list *list);
        int num_reg_slaves(const char *bbdd,int size_reg);       
        
        ////////////////////SLAVE LIST metodos///////////////////////////
	
	private:
		//Do not add custom control declarations between 
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxButton *btn_delete_slave;
		wxTextCtrl *txt_temperature;
		wxStaticText *WxStaticText16;
		wxButton *btn_temperature;
		wxButton *btn_save_bbdd;
		wxButton *btn_close_com;
		wxStaticText *WxStaticText15;
		wxComboBox *cmb_slave_view;
		wxTextCtrl *txt_pin_8;
		wxTextCtrl *txt_pin_7;
		wxTextCtrl *txt_pin_6;
		wxTextCtrl *txt_pin_5;
		wxTextCtrl *txt_pin_4;
		wxTextCtrl *txt_pin_3;
		wxTextCtrl *txt_pin_2;
		wxStaticText *WxStaticText14;
		wxStaticText *WxStaticText13;
		wxStaticText *WxStaticText12;
		wxStaticText *WxStaticText11;
		wxStaticText *WxStaticText10;
		wxStaticText *WxStaticText9;
		wxStaticText *WxStaticText8;
		wxStaticText *WxStaticText7;
		wxTextCtrl *txt_pin_1;
		wxStaticText *WxStaticText6;
		wxComboBox *cmb_recover_config;
		wxButton *btn_recover_config;
		wxStaticText *WxStaticText5;
		wxTextCtrl *txt_introduce_slave;
		wxButton *btn_search_slave;
		wxButton *btn_send_frame;
		wxButton *btn_load_bbdd;
		wxButton *btn_connect_com;
		wxStaticText *WxStaticText4;
		wxRichTextCtrl *hyperterminal;
		wxStaticText *WxStaticText3;
		wxStaticText *WxStaticText2;
		wxStaticText *WxStaticText1;
		wxComboBox *cmb_data;
		wxComboBox *cmb_command;
		wxComboBox *cmb_slave_address;
		////GUI Control Declaration End
				
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_BTN_DELETE_SLAVE = 1047,
			ID_TXT_TEMPERATURE = 1046,
			ID_WXSTATICTEXT16 = 1044,
			ID_BTN_TEMPERATURE = 1043,
			ID_BTN_SAVE_BBDD = 1042,
			ID_BTN_CLOSE_COM = 1041,
			ID_WXSTATICTEXT15 = 1040,
			ID_CMB_SLAVE_VIEW = 1039,
			ID_TXT_PIN_8 = 1038,
			ID_TXT_PIN_7 = 1037,
			ID_TXT_PIN_6 = 1036,
			ID_TXT_PIN_5 = 1035,
			ID_TXT_PIN_4 = 1034,
			ID_TXT_PIN_3 = 1033,
			ID_TXT_PIN_2 = 1032,
			ID_WXSTATICTEXT14 = 1031,
			ID_WXSTATICTEXT13 = 1030,
			ID_WXSTATICTEXT12 = 1029,
			ID_WXSTATICTEXT11 = 1028,
			ID_WXSTATICTEXT10 = 1027,
			ID_WXSTATICTEXT9 = 1026,
			ID_WXSTATICTEXT8 = 1025,
			ID_WXSTATICTEXT7 = 1024,
			ID_TXT_PIN_1 = 1023,
			ID_WXSTATICTEXT6 = 1021,
			ID_CMB_RECOVER_CONFIG = 1020,
			ID_BTN_RECOVER_CONFIG = 1019,
			ID_WXSTATICTEXT5 = 1018,
			ID_TXT_INTRODUCE_SLAVE = 1017,
			ID_BTN_SEARCH_SLAVE = 1014,
			ID_BTN_SEND_FRAME = 1013,
			ID_BTN_LOAD_BBDD = 1012,
			ID_BTN_CONNECT_COM = 1011,
			ID_WXSTATICTEXT4 = 1010,
			ID_HYPERTERMINAL = 1009,
			ID_WXSTATICTEXT3 = 1007,
			ID_WXSTATICTEXT2 = 1006,
			ID_WXSTATICTEXT1 = 1005,
			ID_CMB_DATA = 1004,
			ID_CMB_COMMAND = 1003,
			ID_CMB_SLAVE_ADDRESS = 1002,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
	
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
};

#endif
