#include <stdio.h>
#include <fcntl.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

void DecToHexStr(int dec, char *str)
{ 
	sprintf(str, "%X", dec); 
}

void AsciiToInt(unsigned char *cadena)
{
	while(*cadena)
	{
		if(((*cadena)>=48) && ((*cadena)<=57))
			*cadena = (*cadena)-48;
		else
			*cadena = (*cadena)-55;
		cadena++;
	}
}

int main()
{
	typedef unsigned int   uint32;
	typedef unsigned char  uint8;

	uint32 fd,size,size2;
	uint8 buffer[32768]={0};									//24KB of flash + 8KB of RAM (LPC11E13FBD48/301)

	uint8 sample[8]={0};										//Store a provisional value
	uint8 final_address[4]={0};									//Store the address given to the device
	uint32 seconds;												//Store time without lost

	seconds = time(NULL);										//Time in seconds from January 1, 1970

	//printf("Seconds since January 1, 1970 = %d\n", seconds);

	DecToHexStr(seconds, sample);								//Convert seconds to hexadecimal string and store in sample

	//printf ("Address Device: %s\n",sample);

	AsciiToInt(sample);											//Convert seconds in hexadecimal string to seconds in hexadecimal numbers

	//Interchange positions to see MSB changes every time (CC2500 filter addresses due to MSB byte)

	final_address[3] = sample[0]*16 + sample[1];
	final_address[2] = sample[2]*16 + sample[3];
	final_address[1] = sample[4]*16 + sample[5];
	final_address[0] = sample[6]*16 + sample[7];

	printf ("\nAddress Device: %02X%02X%02X%02X \n\n",final_address[0],final_address[1],final_address[2],final_address[3]);


////////////////////////// FILE HANDLE //////////////////////////////////////////

	fd = open("coderom.bin",O_RDONLY);							//Open file to read

	if(fd == -1)
	{
		printf("Error opening file\n");
		printf("%s\n", strerror(errno));
		return 0;
	}

	size = read(fd, buffer, sizeof(buffer));					//Read file

	if(size == -1)
	{
		printf("Error reading file\n");
		printf("%s\n", strerror(errno));
		return 0;
	}						

	close(fd);													//Close file

	if(fd == -1)
	{
		printf("Error closing file\n");
		printf("%s\n", strerror(errno));
		return 0;
	}

	buffer[0xC9] = final_address[0];							//MSB byte ADDR Register in CC2500

	//Vector with address

	buffer[0xEF] = final_address[0];
	buffer[0xF0] = final_address[1];
	buffer[0xF1] = final_address[2];
	buffer[0xF2] = final_address[3];

	fd = open("coderom.bin",O_WRONLY);							//Open file to write

	if(fd == -1)
	{
		printf("Error opening file\n");
		printf("%s\n", strerror(errno));
		return 0;
	}

	size2 = write(fd, buffer, size);							//Write file

	if(size2 == -1)
	{
		printf("Error writing file\n");
		printf("%s\n", strerror(errno));
		return 0;
	}

	close(fd);													//Close file

	if(fd == -1)
	{
		printf("Error closing file\n");
		printf("%s\n", strerror(errno));
		return 0;
	}

	return 0;
}








